#include <cassert>

#include "util/mytype.h"
#include "util/KanjiConvert.h"

using namespace std;

int countCharSize (const char* eucString, int numOfBytes)
{
  int now = 0;//$B8=:_:]$7$F$$$k>l=j!#(B
  int count = 0;//$B2?(Bchar$BM-$k$+?t$($k!#(B
  while (now < numOfBytes)
    {
      if (isiso (eucString[now]))
	{//iso
	  now++;
	  count++;
	}
      else if (iskanji (eucString[now]))
	{//$BA43Q4A;z(B
	  assert (now < numOfBytes);
	  assert (0x80 & eucString[now+1]);
	  now += 2;
	  count += 2;
	}
      else if (iskana (eucString[now]))
	{//$BH>3Q$+$J(B
	  assert (now < numOfBytes);
	  assert (0x80 & eucString[now+1]);
	  now += 2;
	  count++;
	}
      else
	{
	  DEBUG_MESSAGE ("countCharSize: error?");
	}
    }

  return count;
}
