#include "IO.h"

void* StartRoutine (void* me)
{
  DEBUG_MESSAGE ("PThreadStartRoutine called");
  assert (me != NULL);
  static_cast<IO*>(me)->playLoop ();
  return NULL;
}


int main (int argc,const char** argv)
{
  State state;
  ServerCommand serverCommand;
  Option option;
  IO* io=new IO (&state, &serverCommand, &option);
  //io->initialize ();
  //io->prePlay ();
  
  //io->playLoop ();
  
  pthread_t ioThread;

#if 0
  cerr << "now creating io thread." << endl;
  const int ret =
    pthread_create (&ioThread, NULL, &StartRoutine, static_cast<void*>(io));
  if (ret != 0)
    {
      cerr << "create failed." << endl;
    }
  
  cerr << "now joining" << endl;
  if (pthread_join (ioThread, NULL) != 0)
    {
      cerr << "error:join" << endl;
    }

#else
  cerr << "now creating io thread." << endl;
  if (io->createPlayLoopThread (&ioThread,NULL) != 0)
    {
      cerr << "create failed." << endl;
    }

  cerr << "now joining" << endl;
  if (pthread_join (ioThread, NULL) != 0)
    {
      cerr << "error:join" << endl;
    }

#endif
  
  //io->postPlay ();
  //io->release ();
  cout << "all done" << endl;
  exit (0);
}
