#include "MainIO.h"

int
main (int argc,const char** argv)
{
  State state;
  ServerCommand serverCommand;
  Option option;
  void* retVal2;
  MainIO* io=new MainIO (&state, &serverCommand, &option);
  io->initialize ();
  io->prePlay ();
  
  cerr << "now creating io thread." << endl;
  pthread_t ioThread;
  if (io->createMainLoopThread (&ioThread,NULL)!=0)
    {
      cerr << "create failed." << endl;
    }

#if 1
  cerr << "now joining" << endl;
  if (pthread_join (ioThread,(void**)&retVal2)!=0)
    {
      cerr << "error:join" << endl;
    }
#endif//IO_THREAD
  io->postPlay ();
  io->release ();
  cout << "all done" << endl;
  exit (0);
}
