/*
    IONTrace.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */

#ifndef IONTrace_H
#define IONTrace_H

#include "IONCurses.h"

#define OCTAVE 12 //1 octave12ʤ
#define MAX_OCTAVES 11//noteֹ0-127ʤΤǺ11octavemޤǡ

class IONTrace:public IONCurses
{
protected:
  static const char noteName[OCTAVE];
  char notes[OCTAVE*MAX_OCTAVES+1];//noteɽ
  int octaves;
  /////////////////////////////////////////interfaceɽѡ
  virtual void updateMainWindow ();

  ///////////////////////////////////////////for ncurses

public:
  IONTrace (State* state__, WidiController* widiController__,
	    Option* option__);
  virtual ~IONTrace ();
  virtual void initialize () throw (Error);//Ƽ
};

#endif// IONTrace_H
