#ifndef SherryPaletteEntry_H
#define SherryPaletteEntry_H

#include "util/mytype.h"

class SherryPaletteEntry
{
private:
  uint8 r;
  uint8 g;
  uint8 b;

public:
  SherryPaletteEntry (uint8 r__, uint8 g__, uint8 b__):
    r (r__), g (g__), b (b__)
    {};
  SherryPaletteEntry ():r (0), g (0), b (0) {};
  ~SherryPaletteEntry () {};

  void set (uint8 r__, uint8 g__, uint8 b__)
    {
      r = r__;
      g = g__;
      b = b__;
    };
  void copy (const SherryPaletteEntry& source)
    {
      r = source.getR ();
      g = source.getG ();
      b = source.getB ();
    };
  void reset ()
    {
      r = 0;
      g = 0;
      b = 0;
    };
  uint8 getR () const {return r;};
  uint8 getG () const {return g;};
  uint8 getB () const {return b;};
};

#endif // SherryPaletteEntry_H
