#include "util/KanjiConvert.h"
#include "WrdDumb.h"


void WrdDumb::execNextLine ()
{
  cerr << endl;
}

void WrdDumb::execATMARK ()
{
  cerr << "ATMARK:" << flush;
}

void WrdDumb::execCOLOR (uint32 color_)
{
  cerr << "COLOR :" << color_ << flush;
}

void WrdDumb::execEND ()
{
  cerr << "END:" << flush;
}

#if 0
void WrdDumb::execESC (const char* escStr_)
{
  cerr << "ESC:" << flush;
}
#endif

void WrdDumb::execEXEC (const char* filename)
{
  cerr << "EXEC:" << flush;
}

void WrdDumb::execFADE (uint32 p1,uint32 p2,int speed)
{
  cerr << "FADE:" << flush;
}

void WrdDumb::execGCIRCLE (uint32 x,uint32 y,uint r,uint32 p1,uint32 sw,uint32 p2)
{
  cerr << "GCIRCLE:" << flush;
}

void WrdDumb::execGCLS (uint32 sw)
{
  cerr << "GCLS:" << flush;
}

void WrdDumb::execGINIT ()
{
  cerr << "GINIT:" << flush;
}

void WrdDumb::execGLINE
(uint32 x1,uint32 y1,uint32 x2,uint32 y2,uint32 p1,uint32 sw,uint32 p2)
{
  cerr << "GLINE:" << flush;
}


void WrdDumb::execGMODE (uint32 sw)
{
  cerr << "GMODE:" << flush;
}

void WrdDumb::execGMOVE (uint32 x1,uint32 y1,uint32 x2,uint32 y2,uint32 xd,uint32 yd,uint32 vs,uint32 vd,uint32 sw)
{
  cerr << "GMOVE:" << flush;
}

void WrdDumb::execGON (bool oldIsGraphicOn_, bool isGraphicOn_)
{
  cerr << "GON:" << flush;
}

void WrdDumb::execGSCREEN (uint32 oldActivePage_, uint32 oldDisplayPage_, uint32 activePage_, uint32 displayPage_)
{
  cerr << "GSCREEN:" << flush;
}

void WrdDumb::execINKEY (uint32 barWaitFor_)
{
  cerr << "INKEY:" << flush;
}

void WrdDumb::execLOCATE (uint32 x_,uint32 y_)
{
  cerr << "LOCATE:" << flush;
}

void WrdDumb::execLOOP (uint32 loop)
{
  cerr << "LOOP:" << flush;
}

void WrdDumb::execMAG
(MagFile& mag, int32 x,int32 y,uint32 s,uint32 p)
{
  cerr << "MAG:" << flush;
}


void WrdDumb::execOFFSET (uint32 offsetBarWaitFor_)
{
  cerr << "OFFSET:" << flush;
}

void WrdDumb::execPAL (uint32 page,int32 rgb[16])
{
  cerr << "PAL:" << flush;
}

void WrdDumb::execPALREV (uint32 p)
{
  cerr << "PALREV:" << flush;
}

void WrdDumb::execPLOAD (PH0* ph0)
{
  cerr << "PLOAD:" << flush;
}

void WrdDumb::execREMARK ()
{
  cerr << "REMARK:" << flush;
}

void WrdDumb::execREST (uint32 barOffsetWaitFor,uint32 stepsWaitFor)
{
  cerr << "REST:" << flush;
}

void WrdDumb::execSCROLL (uint32 x1,uint32 y1,uint32 x2,uint32 y2,uint32 mode,uint32 color,uint32 chr)
{
  cerr << "SCROLL:" << flush;
}

void WrdDumb::execSTARTUP (uint32 versoin_)
{
  cerr << "STARTUP:" << flush;
}

void WrdDumb::execSTOP ()
{
  cerr << "STOP:" << flush;
}

void WrdDumb::execTCLS
(uint32 x1,uint32 y1,uint32 x2,uint32 y2,uint32 color,uint32 chr)
{
  cerr << "TCLS:" << flush;
}


void WrdDumb::execTON (uint32 textMode_)
{
  cerr << "TON:" << flush;
}

void WrdDumb::execWAIT (uint32 barWaitFor_,uint32 steptsWaitFor_)
{
  cerr << "WAIT:" << flush;
}

void WrdDumb::execWMODE (uint32 deltaSteps_,uint32 wmode_)
{
  cerr << "WMODE:" << flush;
}

void WrdDumb::execFONTM (int32 fontMode_)
{
  cerr << "FONTM:" << flush;
}

void WrdDumb::execFONTP (uint32 num,uint32 x_,uint32 y_,uint32 attribute)
{
  cerr << "FONTP:" << flush;
}

void WrdDumb::execFONTR (int32 fontNumber,int32 fontData[16])
{
  cerr << "FONTR:" << flush;
}

void WrdDumb::execGSC (int32 mode)
{
  cerr << "GSC:" << flush;
}

void WrdDumb::execLINE (int32 mode)
{
  cerr << "LINE:" << flush;
}

void WrdDumb::execPAL_ (int32 paletteNumber,int32 rgb)
{
  cerr << "PAL_:" << flush;
}

void WrdDumb::execREGSAVE (int32 num,int32 value[WRD_REGSAVE_SIZE_MAX])
{
  cerr << "REGSAVE:" << flush;
}

void WrdDumb::execSCROLL_ (int32 x_,int32 y_)
{
  cerr << "SCROLL_:" << flush;
}

void WrdDumb::execTEXTDOT (int32 textDot_)
{
  cerr << "TEXTDOT:" << flush;
}

void WrdDumb::execTMODE (int32 tmode_)
{
  cerr << "TMODE:" << flush;
}

void WrdDumb::execTSCRL (int32 lines)
{
  cerr << "TSCRL:" << flush;
}

void WrdDumb::execVCOPY (int32 sx1,int32 sy1,int32 sx2,int32 sy2,int32 tx,int32 ty,int32 ss,int32 ts,int32 mode)
{
  cerr << "VCOPY:" << flush;
}

void WrdDumb::execVSGET (int32 page[4])
{
  cerr << "VSGET:" << flush;
}
//XXX 4$B$H=q$/$N$O7y$@$J$!!D(B
void WrdDumb::execVSRES ()
{
  cerr << "VSRES:" << flush;
}

void WrdDumb::execXCOPY (int32 sx1,int32 sy1,int32 sx2,int32 sy2,int32 tx,int32 ty,int32 ss,int32 ts,int32 method,int32 opt[5])
{
  cerr << "XCOPY:" << flush;
}

void WrdDumb::printLYRICS (const char* ptr,int size)
{
  Wrd::printLYRICS (ptr,size);
  cerr << flush;
}

void WrdDumb::printLYRICS1 (const char*& ptr)
{
  Wrd::printLYRICS1 (ptr);
  cerr << flush;
}

void WrdDumb::printChar (uint x_,uint y_,char c,int color_)
{
  cerr << c;
}

void WrdDumb::printChar2b (uint x_,uint y_,char c1,char c2,int color_)
{
  cerr << c1 << c2;
}

void WrdDumb::doEscapeSequence ()
{
  cerr << "WrdDumb::doEscapeSequence" << flush;
}



////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////for dynamic loading
///////////////////////////////////////////////////////////////newIO<T>
///////////////////////////////////////////////////////////////newMainIO<T>
///////////////////////////////////////////////////////////////infoIO<T>
////////////////////////////////////////////////////////////////////////////

#include "IO/InfoIO.h"
static IO* newIOWrdDumb (State* state,WidiController* widiController,
                         Option* option)
{
  return new WrdDumb (state, widiController, option);
}

InfoIO infoIOWrdDumb=
{
  newIOWrdDumb,
  NULL,
  false
};
