/* C code produced by gperf version 2.5 (GNU C++ version) */
/* Command-line: gperf -a -c -C -f -g -l -n -o -p -S 1 -t -k1,2,5,$  */
/*
 * wrd.gperf -- keyfile for gperf. This file is part of xwrdplay.
 *
 * Copyright (C) 1996,1997 Satoshi KURAMOCHI <satoshi@ueda.info.waseda.ac.jp>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include <string.h>
struct resword {
		const char* name ;
		WrdTokenType tokenType ;
		ParameterType parameterType[20] ;
		};

#define TOTAL_KEYWORDS 51
#define MIN_WORD_LENGTH 1
#define MAX_WORD_LENGTH 8
#define MIN_HASH_VALUE 0
#define MAX_HASH_VALUE 117
/* maximum key range = 118, duplicates = 0 */

static unsigned int
hash (register const char *str, register int len)
{
  static const unsigned char asso_values[] =
    {
     118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
     118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
     118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
     118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
     118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
     118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
     118, 118, 118, 118,   0, 118, 118, 118, 118, 118,
     118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
     118, 118, 118, 118, 118, 118, 118, 118, 118, 118,
     118, 118, 118, 118,  10, 118, 118,  30, 118,  41,
      45,  35,  40,   7,   5,  50, 118,   5,   2,  16,
       6,  61,  20, 118,   5,  10,   0, 118,   1,   1,
      15,   0, 118, 118, 118, 118, 118, 118,
    };
  register int hval = 0;

  switch (len)
    {
      default:
      case 5:
        hval += asso_values[str[4]];
      case 4:
      case 3:
      case 2:
        hval += asso_values[str[1]];
      case 1:
        hval += asso_values[str[0]];
        break;
    }
  return hval + asso_values[str[len - 1]];
}

const struct resword *
in_word_set (register const char *str, register int len)
{
  static const struct resword wordlist[] =
    {
      
      {"@", 		tATMARK,	{	{param_end}}},
      {"@wait", 		tWAIT,		{	{param_int,param_noomit},					{param_int,param_omit,0},					{param_end}}},
      {"@rest", 		tREST,		{	{param_int,param_noomit},					{param_int,param_omit,0},					{param_end}}},
      {"@ton", 		tTON,		{	{param_int,param_noomit},					{param_end}}},
      {"^textdot", 	tTEXTDOT,	{	{param_eint,param_noomit},					{param_end}}},
      {"@gon", 		tGON,		{	{param_int,param_omit,1},					{param_end}}},
      {"^tscrl", 		tTSCRL,		{	{param_eint,param_noomit},					{param_end}}},
      {"@gscreen", 	tGSCREEN,	{	{param_int,param_noomit},					{param_int,param_noomit},					{param_end}}},
      {"@tcls", 		tTCLS,		{	{param_int,param_omit,1},					{param_int,param_omit,1},					{param_int,param_omit,80},					{param_int,param_omit,25},					{param_int,param_omit,0},					{param_int,param_omit,' '},					{param_end}}},
      {"@rem", 		tREM,		{	{param_str,param_omit,0},					{param_end}}},
      {"@pal", 		tPAL,		{	{param_no, param_omit,0},					{param_hex,param_noomit},					{param_hex,param_noomit},					{param_hex,param_noomit},					{param_hex,param_noomit},					{param_hex,param_noomit},					{param_hex,param_noomit},					{param_hex,param_noomit},					{param_hex,param_noomit},					{param_hex,param_noomit},					{param_hex,param_noomit},					{param_hex,param_noomit},					{param_hex,param_noomit},					{param_hex,param_noomit},					{param_hex,param_noomit},					{param_hex,param_noomit},					{param_hex,param_noomit},					{param_end}}},
      {"@mag", 		tMAG,		{	{param_str,param_noomit},					{param_eint,param_omit,-1},					{param_eint,param_omit,-1},					{param_int,param_omit,1},					{param_int,param_omit,0},					{param_end}}},
      {"@palrev", 	tPALREV,	{	{param_int,param_noomit},					{param_end}}},
      {"@gcls", 		tGCLS,		{	{param_int,param_omit,15},					{param_end}}},
      {"@path", 		tPATH,		{	{param_str,param_omit,'.'},					{param_end}}},
      {"^vcopy", 		tVCOPY,		{	{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_end}}},
      {"^pal", 		tPAL_,		{	{param_eint,param_noomit},					{param_eint,param_noomit},					{param_end}}},
      {"@startup", 	tSTARTUP,	{	{param_int,param_omit,-1},					{param_end}}},
      {"@remark", 	tREMARK,	{	{param_str,param_omit,0},					{param_end}}},
      {"@loop", 		tLOOP,		{	{param_int,param_noomit},					{param_end}}},
      {"@gmove", 		tGMOVE,		{	{param_int,param_noomit},					{param_int,param_noomit},					{param_int,param_noomit},					{param_int,param_noomit},					{param_int,param_noomit},					{param_int,param_noomit},					{param_int,param_omit,0},					{param_int,param_omit,0},					{param_int,param_omit,0},					{param_end}}},
      {"^xcopy", 		tXCOPY,		{	{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_omit,0},					{param_eint,param_omit,0},					{param_eint,param_omit,0},					{param_eint,param_omit,0},					{param_eint,param_omit,0},					{param_end}}},
      {"^vsget", 		tVSGET,		{	{param_eint,param_noomit},					{param_eint,param_omit,4},					{param_eint,param_omit,2},					{param_eint,param_omit,1},					{param_end}}},
      {"@gcircle", 	tGCIRCLE,	{	{param_int,param_noomit},					{param_int,param_noomit},					{param_int,param_noomit},					{param_int,param_noomit},					{param_int,param_noomit},					{param_int,param_omit,0},					{param_end}}},
      {"@gline", 		tGLINE,		{	{param_int,param_noomit},					{param_int,param_noomit},					{param_int,param_noomit},					{param_int,param_noomit},					{param_int,param_noomit},					{param_int,param_omit,0},					{param_int,param_omit,1},					{param_end}}},
      {"@stop", 		tSTOP,		{	{param_end}}},
      {"@screen", 	tSCREEN,	{	{param_end}}},
      {"^fontr", 		tFONTR,		{	{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_end}}},
      {"^vsres", 		tVSRES,		{	{param_end}}},
      {"@ginit", 		tGINIT,		{	{param_end}}},
      {"^gsc", 		tGSC,		{	{param_eint,param_noomit},					{param_end}}},
      {"^regsave", 	tREGSAVE,	{	{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_omit,-1},					{param_eint,param_omit,-1},					{param_eint,param_omit,-1},					{param_eint,param_omit,-1},					{param_eint,param_omit,-1},					{param_eint,param_omit,-1},					{param_eint,param_omit,-1},					{param_eint,param_omit,-1},					{param_eint,param_omit,-1},					{param_eint,param_omit,-1},					{param_eint,param_omit,-1},					{param_eint,param_omit,-1},					{param_eint,param_omit,-1},					{param_eint,param_omit,-1},					{param_eint,param_omit,-1},					{param_end}}},
      {"^fontm", 		tFONTM,		{	{param_eint,param_noomit},					{param_end}}},
      {"@locate", 	tLOCATE,	{	{param_int,param_noomit},					{param_int,param_noomit},					{param_end}}},
      {"@palchg", 	tPALCHG,	{	{param_str,param_noomit},					{param_end}}},
      {"^fontp", 		tFONTP,		{	{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_eint,param_noomit},					{param_end}}},
      {"@offset", 	tOFFSET,	{	{param_int,param_noomit},					{param_end}}},
      {"@scroll", 	tSCROLL,	{	{param_int,param_omit,1},					{param_int,param_omit,1},					{param_int,param_omit,80},					{param_int,param_omit,25},					{param_int,param_omit,0},					{param_int,param_omit,0},					{param_int,param_omit,' '},					{param_end}}},
      {"@esc", 		tESC,		{	{param_str,param_noomit},					{param_end}}},
      {"@end", 		tEND,		{ 	{param_end}}},
      {"@wmode", 		tWMODE,		{	{param_int,param_noomit},					{param_int,param_omit,0},					{param_end}}},
      {"^line", 		tLINE,		{	{param_eint,param_noomit},					{param_end}}},
      {"^scroll", 	tSCROLL_,	{	{param_eint,param_noomit},					{param_eint,param_noomit},					{param_end}}},
      {"@inkey", 		tINKEY,		{	{param_int,param_noomit},					{param_end}}},
      {"@gmode", 		tGMODE,		{	{param_int,param_noomit},					{param_end}}},
      {"^tmode", 		tTMODE,		{	{param_eint,param_noomit},					{param_end}}},
      {"@pload", 		tPLOAD,		{	{param_str,param_noomit},					{param_end}}},
      {"@color", 		tCOLOR,		{	{param_int,param_noomit},					{param_end}}},
      {"@fade", 		tFADE,		{	{param_int,param_noomit},					{param_int,param_noomit},					{param_eint,param_omit,-1},					{param_end}}},
      {"@midi", 		tMIDI,		{	{param_hex,param_noomit},					{param_hex,param_omit},					{param_hex,param_omit},					{param_hex,param_omit},					{param_hex,param_omit},					{param_hex,param_omit},					{param_hex,param_omit},					{param_hex,param_omit},					{param_hex,param_omit},					{param_hex,param_omit},					{param_end}}},
      {"@exec", 		tEXEC,		{	{param_str,param_noomit},					{param_end}}},
    };

  if (len <= MAX_WORD_LENGTH && len >= MIN_WORD_LENGTH)
    {
      register int key = hash (str, len);

      if (key <= MAX_HASH_VALUE && key >= MIN_HASH_VALUE)
        {
            {
              const struct resword  *resword; int key_len;

              switch (key)
                {
                case    0:
                  resword = &wordlist[0]; key_len = 1; break;
                case    1:
                  resword = &wordlist[1]; key_len = 5; break;
                case    5:
                  resword = &wordlist[2]; key_len = 5; break;
                case    6:
                  resword = &wordlist[3]; key_len = 4; break;
                case   10:
                  resword = &wordlist[4]; key_len = 8; break;
                case   13:
                  resword = &wordlist[5]; key_len = 4; break;
                case   17:
                  resword = &wordlist[6]; key_len = 6; break;
                case   18:
                  resword = &wordlist[7]; key_len = 8; break;
                case   20:
                  resword = &wordlist[8]; key_len = 5; break;
                case   21:
                  resword = &wordlist[9]; key_len = 4; break;
                case   22:
                  resword = &wordlist[10]; key_len = 4; break;
                case   23:
                  resword = &wordlist[11]; key_len = 4; break;
                case   26:
                  resword = &wordlist[12]; key_len = 7; break;
                case   27:
                  resword = &wordlist[13]; key_len = 5; break;
                case   30:
                  resword = &wordlist[14]; key_len = 5; break;
                case   31:
                  resword = &wordlist[15]; key_len = 6; break;
                case   32:
                  resword = &wordlist[16]; key_len = 4; break;
                case   35:
                  resword = &wordlist[17]; key_len = 8; break;
                case   40:
                  resword = &wordlist[18]; key_len = 7; break;
                case   42:
                  resword = &wordlist[19]; key_len = 5; break;
                case   43:
                  resword = &wordlist[20]; key_len = 6; break;
                case   45:
                  resword = &wordlist[21]; key_len = 6; break;
                case   46:
                  resword = &wordlist[22]; key_len = 6; break;
                case   47:
                  resword = &wordlist[23]; key_len = 8; break;
                case   48:
                  resword = &wordlist[24]; key_len = 6; break;
                case   50:
                  resword = &wordlist[25]; key_len = 5; break;
                case   51:
                  resword = &wordlist[26]; key_len = 7; break;
                case   55:
                  resword = &wordlist[27]; key_len = 6; break;
                case   56:
                  resword = &wordlist[28]; key_len = 6; break;
                case   57:
                  resword = &wordlist[29]; key_len = 6; break;
                case   58:
                  resword = &wordlist[30]; key_len = 4; break;
                case   60:
                  resword = &wordlist[31]; key_len = 8; break;
                case   66:
                  resword = &wordlist[32]; key_len = 6; break;
                case   67:
                  resword = &wordlist[33]; key_len = 7; break;
                case   68:
                  resword = &wordlist[34]; key_len = 7; break;
                case   70:
                  resword = &wordlist[35]; key_len = 6; break;
                case   71:
                  resword = &wordlist[36]; key_len = 7; break;
                case   73:
                  resword = &wordlist[37]; key_len = 7; break;
                case   76:
                  resword = &wordlist[38]; key_len = 4; break;
                case   80:
                  resword = &wordlist[39]; key_len = 4; break;
                case   81:
                  resword = &wordlist[40]; key_len = 6; break;
                case   82:
                  resword = &wordlist[41]; key_len = 5; break;
                case   83:
                  resword = &wordlist[42]; key_len = 7; break;
                case   85:
                  resword = &wordlist[43]; key_len = 6; break;
                case   87:
                  resword = &wordlist[44]; key_len = 6; break;
                case   90:
                  resword = &wordlist[45]; key_len = 6; break;
                case   95:
                  resword = &wordlist[46]; key_len = 6; break;
                case  107:
                  resword = &wordlist[47]; key_len = 6; break;
                case  110:
                  resword = &wordlist[48]; key_len = 5; break;
                case  116:
                  resword = &wordlist[49]; key_len = 5; break;
                case  117:
                  resword = &wordlist[50]; key_len = 5; break;
                default: return 0;
                }
              if (len == key_len && *str == *resword->name && !strncmp (str + 1, resword->name + 1, len - 1))
                return resword;
              return 0;
            }
         }
    }
  return 0;
}
