#ifndef GTKBase_H
#define GTKBase_H

#include "util/Mutex.h"
#include "PlugIn/X/XBase/XBase.h"

//mixin for GTK
class GTKBase:public XBase
{
private:
  static Mutex gtkLock;
  //XXX gtk_init$B$N0z?t$KM?$($k$b$N!#0lBN2?$r;XDj$7$?$iNI$$$b$N$d$i!#(B
  static int gtkArgc;
  static char** gtkArgv;
  
  static int nrChild;
  static pthread_once_t gtkInit;
  static void initGTK ();
  static void* gtkMain (void*);
  static pthread_t gtkMainThread;
public:
  GTKBase ();
  ~GTKBase ();
};
#endif // GTKBase_H
