#include <cstdio>
#include <unistd.h>

#include "WtkEventHandler.h"
#include "WtkButton.h"
#include "WtkLabel.h"

class Oops
{
public:
  WtkLabel* label;
  Oops (WtkWidget* parent,const char* className,const char* resourceName,int x,int y,uint width,uint height)
    {
      label=new WtkLabel (parent,className,resourceName,x,y,width,height);
      label->setLabel ("Click me!");
      label->map ();
    };
  ~Oops (){delete label;};
  
  void oops (const XEvent* event)
    {
      label->setLabel ("Oops!");
    };
  void blah ()
    {
      cerr << "blah" << endl;
    };
};

main ()
{
  Display* display=XOpenDisplay (NULL);
  int screen=DefaultScreen (display);
  Colormap colormap=DefaultColormap (display,screen);
  int depth=DefaultDepth (display,screen);
  Visual* visual=DefaultVisual (display,screen);

  XrmInitialize ();
  WtkWidget widget (display,"Test","test",0,0,640,400,depth,visual,colormap,
		    "testWtkWidget.ad");
  WtkWidget child (&widget,"Child","child",10,10,300,300);
  WtkButton button  (&child,"Button","button",10,10,100,100);
  Oops oops (&widget,"Label","label",200,200,80,80);
  button.clicked.connect (&oops,&Oops::oops);
  XEvent event;
  //button.clicked (&event);
  button.map ();
  child.map ();
  widget.map ();
  //widget.rmPutFileDatabase ("result.ad");
  
  WtkEventHandler eventHandler (display);
  eventHandler.addWidget (&widget);
  eventHandler.addWidget (&child);
  eventHandler.addWidget (&button);
  eventHandler.addWidget (oops.label);
  eventHandler.createEventLoopThread ();
  XFlush (display);
  

  for (int i=0;i<5;i++)
    {
      sleep (10);
      XFlush (display);
    }
  eventHandler.cancelEventLoopThread ();
  cerr << "canceled" << endl;
  eventHandler.createEventLoopThread ();

  getchar ();
}
