#include <cstdio>
#include <unistd.h>

#include "WtkEventHandler.h"
#include "WtkLevel.h"

main ()
{
  Display* display=XOpenDisplay (NULL);
  int screen=DefaultScreen (display);
  Colormap colormap=DefaultColormap (display,screen);
  int depth=DefaultDepth (display,screen);
  Visual* visual=DefaultVisual (display,screen);

  XrmInitialize ();
  WtkLevel level (display,"Test","test",0,0,640,400,depth,visual,colormap,
		  "testWtkWidget.ad");
  level.setLevel (0.5);
  level.map ();

  WtkEventHandler eventHandler (display);
  eventHandler.addWidget (&level);
  eventHandler.createEventLoopThread ();
  XFlush (display);

  XFlush (display);
  cerr << "event loop" << endl;
#define LEVEL_UNIT 256.0
  for (int i=0;i<LEVEL_UNIT;i++)
    {
      usleep (1);
      level.setLevel (i/LEVEL_UNIT);
      XFlush (display);
    }
  for (int i=static_cast<int>(LEVEL_UNIT);i>0;i--)
    {
      usleep (1);
      level.setLevel (i/LEVEL_UNIT);
      XFlush (display);
    }
#undef LEVEL_UNIT
  level.setLevel (1.0);
  XFlush (display);
  getchar ();
  level.setLevel (0.0);
  XFlush (display);
  getchar ();
}
