#include <cstdio>
#include <unistd.h>

#include "WtkEventHandler.h"
#include "WtkMaxedLevel.h"

main ()
{
  Display* display=XOpenDisplay (NULL);
  int screen=DefaultScreen (display);
  Colormap colormap=DefaultColormap (display,screen);
  int depth=DefaultDepth (display,screen);
  Visual* visual=DefaultVisual (display,screen);

  XrmInitialize ();
  WtkMaxedLevel maxedLevel (display,"Test","test",0,0,640,400,
			    depth,visual,colormap,
			    "testWtkWidget.ad");
  maxedLevel.setLevel (0.5,0.7);
  maxedLevel.map ();

  WtkEventHandler eventHandler (display);
  eventHandler.addWidget (&maxedLevel);
  eventHandler.createEventLoopThread ();
  XFlush (display);

  XFlush (display);
  cerr << "event loop" << endl;

  for (int i=0;i<1024;i++)
    {
      usleep (1);
      maxedLevel.setLevel (i/1024.0,(i+100)/1024.0);
      XFlush (display);
    }

  for (int i=1024;i>0;i--)
    {
      usleep (1);
      maxedLevel.setLevel (i/1024.0,(i+100)/1024.0);
      XFlush (display);
    }
  
  getchar ();
}
