#include "SequencerMIDI.h"

int main ()
{
  State state;
  int midiDeviceNum = 0;
  Option option;
  Sequencer* sequencer;
  try
    {
      sequencer = new SequencerMIDI (&state, midiDeviceNum, &option);
    }
  catch (Sequencer::SequencerError&)
    {
      cerr << "can not initialize midi device" << endl;
      return 1;
    }

  cout << "wainting keys..." << endl;
  cin.get ();

  delete sequencer;
  return 0;
}
