/*
    SMFBufferStream.cc
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#include "SMFBufferStream.h"

SMFBufferStream::SMFBufferStream (const char* const bufferHead,int size):
  SongBufferStream (bufferHead,size)
{
  //do nothing
}

SMFBufferStream::SMFBufferStream ():
  SongBufferStream ()
{
  //do nogthing
}

SMFBufferStream::~SMFBufferStream ()
{
  //do nothing
}

uint32 SMFBufferStream::getVariableLength () throw (Error)
{
  uint32 value=0;
  int tmp;
  do
    {
      tmp=get8 ();
      value=(value << 7)+(tmp&0x7f);
    }while ((tmp&0x80)!=0);
#ifdef DEBUG
  //cerr << "value=" << value << endl;
#endif
  return value;
}
