/*
    SMFInputStream.cc
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#include "SMFInputStream.h"

SMFInputStream::SMFInputStream (const string& filename_,
				int mode = ios::in|ios::nocreate):
  SongInputStream (filename_, mode)
{
  //do nothing
}

SMFInputStream::~SMFInputStream ()
{
  //do nothing
}

int SMFInputStream::getVariableLength () throw (Error)
{
  int value = 0;
  int tmp;
  do
    {
      tmp = get8 ();
      value = (value << 7) + (tmp&0x7f);
    }while ((tmp&0x80) != 0);
  return value;
}
