/*
    RCPBufferStream.cc
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#include "RCPBufferStream.h"

RCPBufferStream::RCPBufferStream (const char* const bufferHead,int size):
  SongBufferStream (bufferHead,size)
{
  //do nothing
}

RCPBufferStream::RCPBufferStream ():
  SongBufferStream ()
{
  //do nogthing
}

RCPBufferStream::~RCPBufferStream ()
{
  //do nothing
}

void RCPBufferStream::skipReservedArea (int size,uchar pad=0x00) throw (Error)
{
  uchar* tmp1=new uchar[size];
  uchar* tmp2=new uchar[size];
  memset (tmp1,pad,size);
  read (tmp2,size);
  if (memcmp (tmp1,tmp2,size)!=0)
    {
      Error error ("in reserved area not 0x00 is found.");
      throw (error);
    }
}
