/*
    RCPBufferStream.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */
#ifndef RCPBufferStream_H
#define RCPBufferStream_H

#include "Song/SongBufferStream.h"

class RCPBufferStream:public SongBufferStream
{
public:
  RCPBufferStream (const char* const bufferHead,int size);
  RCPBufferStream ();
  virtual ~RCPBufferStream ();
  //size$B$@$1(Bbuffer$B$r%9%-%C%W$9$k!#(B
  //reserved area$B$O(B0x00$B$GKd$a$i$l$F$$$k$O$:$@$+$i$=$l$b%A%'%C%/$9$k!#(B
  void skipReservedArea (int size,uchar pad=0x00) throw (Error);
};
#endif // RCPBufferStream_H
