#include "Archive.h"
#include "MemoryStream.h"

Archive::Archive (const char* path):
  DataStream (path),dataStream (NULL)
{
  //open the file,and make dataStream to the file
  //XXX
}

Archive::Archive (const char* parentDir,const char* fileName):
  DataStream (parentDir,fileName),dataStream (NULL)
{
  //open the file,and make dataStream to the file
  //XXX
}

Archive::Archive (DataStream* dataStream_):
  DataStream (dataStream_->getParentName (),dataStream_->getBaseName ()),
  dataStream (dataStream_)
{
  assert (dataStream!=NULL);
}

Archive::Archive (const char* name,const char* data_,long size):
  DataStream (name),
  dataStream (new MemoryStream (name, data_ ,size))
{
  assert (dataStream!=NULL);
}


Archive::~Archive ()
{
  delete dataStream;
}
