#ifndef Archive_H
#define Archive_H

#include <list>

#include "FileStream.h"
#include "MemoryBuffer.h"

using namespace std;

class Archive:public DataStream
{
protected:
  //read the data form
  DataStream* dataStream;
  //Mutex dataStreamLock;//need this? ???
  
  //EntryNode.userData=static_cast<void*>(&ArchiveEntryNode)
  //ȤƻȤ
  //class ArchiveEntryNode:public EntryNode::UserData//this couse egcs's bug!!!
  class ArchiveEntryNode:public DataStream::EntryNode::UserData
  {
  public:
    //dataSize,originalDataSize ==-1 if 'size's are non-sense
    long compressedSize;//compressed data size
    long uncompressedSize;//uncompressed size
    UserData* userData;//user data !!!should not be array!!!
    ArchiveEntryNode ():
      compressedSize (-1),uncompressedSize (-1),userData (NULL){};
    //Ǥ⤳memory leakʤۡ
    virtual ~ArchiveEntryNode (){delete userData;};
  };
  
  //constructors
  Archive (const char* path);
  Archive (const char* parentDir,const char* fileName);
  //dataStream_򿷤newͿɬפ롣
  //destructdata_ϼưŪdelete롣
  //Ĥޤꡢ¾data_򻲾ȤƤϤʤ
  //!!! dataStream_destruct˲롣!!!
  Archive (DataStream* dataStream_);
  Archive (const char* name,const char* data_,long size);
public:
  //destructor
  virtual ~Archive ();
  
  //methods
  virtual void close ()=0;//throw (UnavailableOperarion)
  virtual long read (char* buffer,long size)// throw (UnavailableOperation)
    {throw UnavailableOperation();};
  virtual long seekg (long pos,Whence whence=cur)//throw (UnavailableOperation)
    {throw UnavailableOperation();};
  virtual long tellg () {return dataStream->tellg ();};

  virtual bool isRandomAccessible () const {return false;};
};
#endif // Archive_H

