#ifndef ThreadedMemoryStream_H
#define ThreadedMemoryStream_H

#include "DataStream.h"
#include "MemoryBuffer.h"
#include "Threaded.h"

class ThreadedMemoryStream:public DataStream,public Threaded<MemoryBuffer>
{
public:
  ThreadedMemoryStream (const char* parentName,const char* baseName);
  ThreadedMemoryStream (DataStream* dataStream_,
			bool doesCreateRetrieveThread=true);
  virtual ~ThreadedMemoryStream ();


  virtual void close ();//ɤ߹ߤ˻ȤäƤstream˴buffer˴ //???
  virtual long read (char* buffer,long size){return read (buffer,size,true);};
  virtual long read (char* buffer,long size,bool doesBlock);
  virtual long seekg (long pos,Whence whence=cur)
    {return seekg (pos,whence,true);};
  //!!!NOTE!!!
  //whence=end,doesBlock=trueλdataޤblock롣
  //whence=end,doesBlock=falseλϺbufferκǸ˰ưǡ
  //θǡ夹ǽ롣(when dataStream->eod()==false)
  virtual long seekg (long pos,Whence whence=cur,bool doesBlock=true);
  virtual long rewind ()
    {assert (memoryBuffer!=NULL);memoryBuffer->rewind ();return 0;};
  virtual long tellg () {return memoryBuffer->tellg ();};
  virtual bool eod () const {return memoryBuffer->eod ();};

  virtual bool isRandomAccessible () const {return true;};
};
#endif // ThreadedMemoryStream_H
