#ifndef ___LZH_H_
#define ___LZH_H_

#ifdef __cplusplus
extern "C"
{
#endif

typedef struct _UNLZHHandler *UNLZHHandler;

  /*
    long (* read_func)(char* data ,long size ,void* user_val)
    unlzh$B$,(BLZH$B05=L$5$l$?%G!<%?$rFI$_=P$9$N$K;H$&!#(B
   */
extern UNLZHHandler open_unlzh_handler(long (* read_func)(char*,long,void*),
				       const char *method,
				       long compsize, long origsize,
				       void *user_val);
extern long unlzh(UNLZHHandler decoder, char *buff, long buff_size);
extern void close_unlzh_handler(UNLZHHandler decoder);

extern char *lzh_methods[];


#ifdef __cplusplus
}
#endif 
#endif /* ___LZH_H_ */
