#include <typeinfo>

#include "Directory.h"

void readDir (Directory& dir)
{
  DataStream::ChildrenList fileList=dir.getChildrenList ();
  for (DataStream::ChildrenList::iterator i=fileList.begin ();
       i!=fileList.end ();i++)
    {
      cout << (*i)->filename << endl;
      DataStream* child=dir.newChild (i);
      if (child->isArchive ())
	{
	  cout << "opening directory" << endl;
	  readDir (*dynamic_cast<Directory*>(child));
	}
      delete child;
    }
}


int main (int argc,char** argv)
{
  const char* path;
  if (argc<=1)
    path=".";
  else
    path=argv[1];
  
  Directory dir (path);
  readDir (dir);
}
