#include "LZHMember.h"
#include "ThreadedMemoryStream.h"

main (int argc,char** argv)
{
  if (argc<2)
    exit (-1);

  const char* const filename=argv[1];
  cout << "DEBUG:newing LZH" << endl;
  LZH* lzh=new LZH (new FileStream (filename));
  cout << "DEBUG:newed LZH" << endl;
  
  DataStream::ChildrenList& list=lzh->getChildrenList ();
  for (DataStream::ChildrenList::iterator i=list.begin ();i!=list.end ();i++)
    {
      cout << (*i)->filename << endl;
      cout << "DEBUG:newing stream" << endl;
      DataStream* stream=new ThreadedMemoryStream (lzh->newChild (i));
      assert (stream!=NULL);
      cout << "DEBUG:newd stream" << endl;
#define BUFFER_SIZE 1024
      char buffer[BUFFER_SIZE];
      long size;
      while ((size=stream->read (buffer,BUFFER_SIZE))>0)
	{
	  cout << "size=" << size << endl;
	  cout.write (buffer,size) << endl;
	}
#undef BUFFER_SIZE
      cout << "DEBUG:deleting stream" << endl;
      delete stream;
      cout << "DEBUG:deleted stream" << endl;
    }
  delete lzh;
}
