#ifndef TimerConnection_H
#define TimerConnection_H

class TimerConnection
{
protected:
  TimerConnection (){/*do nothing*/};
  
public:
  virtual void call () = 0;
};

template <typename T>
class TimerConnectionImple:public TimerConnection
{
private:
  T* const obj;
  void (T::*const method) (void* arg);
  void* const arg;
  
public:
  TimerConnectionImple (T* obj__, void (T::*method__) (void*), void* arg__):
    obj (obj__), method (method__), arg (arg__) {/*do nothing*/};
  
  virtual void call ()
    {(obj->*method) (arg);};
};
#endif// TimerConnection_H
