#include <iostream>
#include <unistd.h>

#include "Timer.h"
#include "util/Random.h"

using namespace std;

class Handler
{
public:
  void timeOut (void* arg)
    {
      cout << "Handler::timeOut " << *static_cast<int*>(arg) << endl;
    };
};


int main ()
{
  Timer* timer = new Timer ();
  Handler handler;
  const int MAX_TIME = 10;
  const int MAX_TAGS = 100;
  int time[MAX_TAGS];
  int id[MAX_TAGS];
  Timer::Tag tag[MAX_TAGS];
  Random random;
  for (int i = 0; i < MAX_TAGS; i++)
    {
      id[i] = i;
      time[i] = random (MAX_TIME);
    }
  
  
  for (int i = 0; i < MAX_TAGS; i++)
    {
      tag[i] = timer->connect (static_cast<uint32> (time[i]*1000),
			       &handler, &Handler::timeOut, &id[i]);
      cout << "tag[" << i << "] = " << tag[i] << endl;
    }
  
  
  timer->disconnect (tag[4]);
  timer->disconnect (tag[7]);
  sleep (MAX_TIME+2);
  delete timer;
  return 0;
}
