#ifndef getCurrentWorkingDirectory_H
#define getCurrentWorkingDirectory_H

#include <unistd.h>
#include <string>

using namespace std;

//curreint working directory$B$r(B cwd$B$K@_Dj$7$FJV$9!#(B
//$BEvA3!"(Bcwd$B$NCf?H$OGK2u$5$l$k!#(B
void getCurrentWorkingDirectory (string& cwd)
{
  assert (cwd.length () == 0);

  char* buffer = NULL;
  char* absDirname = NULL;
  size_t size = 256;
  while (absDirname == NULL)
    {
      delete[] buffer;
      buffer = new char[size];
      absDirname = getcwd (buffer, size);
      size *= 2;
    }

  cwd = absDirname;
  delete[] buffer;
}
#endif //getCurrentWorkingDirectory_H
