/*
    mymytype.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */

#ifndef mytype_H
#define mytype_H

#include <iostream>

using namespace std;

typedef unsigned long ulong;
typedef unsigned int uint;
typedef int int32;
typedef unsigned int uint32;
typedef short int16;
typedef unsigned short uint16;
typedef signed char int8;
typedef unsigned char uint8;
typedef unsigned char uchar;

#ifdef DEBUG
inline void DEBUG_MESSAGE (const char* message)
{
  cerr << message << endl;
};
#else
inline void DEBUG_MESSAGE (const char* /*message*/)
{
  //do nothing
};
#endif
#endif // mytype_H
