#ifndef SourceFileItem_H
#define SourceFileItem_H

#include <string>

#include "util/mytype.h"

using namespace std;

class SourceFileItem
{
private:
  const int16 number;
  const string filename;
public:
  SourceFileItem (int16 number__, const string& filename__):
    number (number__), filename (filename__) {};
  ~SourceFileItem () {};

  int16 getNumber () const {return number;};
  const string& getFileName () const {return filename;};
};

#endif //SourceFileItem_H
