#include <cstdio>
#include <unistd.h>

#include "WtkEventHandler.h"
#include "WtkWidget.h"
#include "WtkLabel.h"

main ()
{
  Display* display=XOpenDisplay (NULL);
  int screen=DefaultScreen (display);
  Colormap colormap=DefaultColormap (display,screen);
  int depth=DefaultDepth (display,screen);
  Visual* visual=DefaultVisual (display,screen);

  XrmInitialize ();
  WtkWidget widget (display,"Test","test",0,0,640,400,depth,visual,colormap,
		    "testWtkWidget.ad");
  WtkWidget child (&widget,"Child","child",10,10,300,300);
  WtkLabel label (&child,"Label","label",10,10,100,10);
  label.setLabel ("LABEL");
  label.map ();
  child.map ();
  widget.map ();
  //widget.rmPutFileDatabase ("result.ad");
  
  WtkEventHandler eventHandler (display);
  eventHandler.addWidget (&widget);
  eventHandler.addWidget (&child);
  eventHandler.addWidget (&label);
  eventHandler.createEventLoopThread ();
  XFlush (display);
  

  for (int i=0;i<5;i++)
    {
      sleep (1);
      char buf[100];
      sprintf (buf,"Label %d",i);
      label.setLabel (buf);
      XFlush (display);
    }
  eventHandler.cancelEventLoopThread ();
  cerr << "canceled" << endl;
  eventHandler.createEventLoopThread ();

#if 0
  for (int i=0;i<5;i++)
    {
      sleep (1);
      char buf[100];
      sprintf (buf,"Label %d",i);
      label.setLabel (buf);
      XFlush (display);
    }
#endif
  
#if 0
  for (;;)
    {
      eventHandler.createEventLoopThread ();
      eventHandler.cancelEventLoopThread ();
      cerr << "canceled" << endl;
    }
#endif
  
  getchar ();
}
