#include "InfoSequencer.h"

Sequencer* InfoSequencer::createSequencer (DlHandler* handler,
					   const string& name,
					   State* state_, Option* option_)
{
  string infoSequencerName = "infoSequencer";
  infoSequencerName += name;
  InfoSequencer* infoSequencer =
    static_cast<InfoSequencer*>(handler->sym (infoSequencerName));

  if (infoSequencer == NULL)
    return NULL;

  return infoSequencer->newSequencer (state_, option_);
}

