/*
    SequencerNull.cc
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */

#include "SequencerNull.h"

const int SequencerNull::ctrlRate;

SequencerNull::SequencerNull (State* state_,Option* option_):
  Sequencer (state_,option_),isTimerWorking (false),dummyMutex (),dummyCond ()
{
  //do nothing
}

SequencerNull::~SequencerNull ()
{
  //do nothing
}


////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////for dynamic loading
///////////////////////////////////////////////////////////newSequencer<T>
//////////////////////////////////////////////////////////infoSequencer<T>
////////////////////////////////////////////////////////////////////////////
#include "InfoSequencer.h"

static Sequencer* newSequencerNull (State* state_, Option* option_)
{
  return new SequencerNull (state_, option_);
}

InfoSequencer infoSequencerNull =
{
  newSequencerNull
};


