/*
    G36Track.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */
#ifndef G36Track_H
#define G36Track_H

#include "RCPTrack.h"

class G36Track:public RCPTrack
{
public:
  static const int G36_TRACK_HEADER_SIZE=46;
  G36Track ();
  virtual void readTrackData (RCPBufferStream& rcpBufferStream) throw (Error);
  ~G36Track ();
  uint32 G36Track::peekStepTime () const;
};

#endif // G36Track_H
