/*
    Rythm.cc
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */


#include "Rythm.h"

const int Rythm::MAX_INSTRUMENT_NAME_LENGTH;

Rythm::Rythm ():
  keyNumber (0),gt (0)
{
  memset (instrument,0x20,MAX_INSTRUMENT_NAME_LENGTH);
}

Rythm::~Rythm ()
{
  //do nothing
}
  
void Rythm::load (RCPBufferStream& rcpBufferStream)
{
  rcpBufferStream.read (instrument,MAX_INSTRUMENT_NAME_LENGTH);
  keyNumber=rcpBufferStream.get8 ();
  gt=rcpBufferStream.get8 ();
}
