/*
    Rythm.h
  
    Copyright (C) 1998 Isaku Yamahata

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
    */
#ifndef Rythm_H
#define Rythm_H

#include "Song/recomposer/RCPBufferStream.h"

class Rythm
{
public:
  Rythm ();
  ~Rythm ();
  void load (RCPBufferStream& rcpBufferStream);
  static const int MAX_INSTRUMENT_NAME_LENGTH=14;
  char instrument[MAX_INSTRUMENT_NAME_LENGTH];
  uchar keyNumber;
  uchar gt;
};
#endif // Rythm_H
