#ifndef LZHMember_H
#define LZHMember_H

#include "Extracter.h"
#include "LZH.h"

#include "unlzh.h"

class LZHMember:public Extracter
{
protected:
  friend LZH;
  EntryNode* entryNode;
  Archive::ArchiveEntryNode* archiveEntryNode;
  LZH::LZHEntryNode* lzhEntryNode;

  UNLZHHandler unlzhHandler;
#ifdef USE_DYNAMIC_CAST
  static long readFunc (char* data,long size,/*DataStream**/void* dataStream_);
#else
  static long readFunc (char* data,long size,DataStream* dataStream_);
#endif

  //äentryNodedestructdelete롣
  LZHMember (EntryNode* entryNode_);
public:
  virtual ~LZHMember ();
  virtual long read (char* buffer,long size);
  virtual bool eod (){return (readSize==archiveEntryNode->uncompressedSize);};
  virtual bool isRandomAccessible () const {return false;};
};
#endif // LZHMember_H
