#ifndef URL_H
#define URL_H

#include "DataStream.h"

class URL:public DataStream
{
protected:
  //static const char* const schemeName;
  long dataSize;//
  long readSize;//$BFI$_=P$7$?%G!<%?$N%5%$%:(B

  //http://,ftp://,file://,dir://,news://,etc...
  //static bool isSupported (const char* url);
  URL (const char* url):DataStream (url),dataSize (0),readSize (0) {};
public:
  virtual ~URL ();

  virtual void close ()=0;//close the connection
  virtual void long read (char* buffer,long size)=0;
  virtual void long seekg (long pos,Whence whence=cur)
    {assert (false);throw UnavailableOperation ();};
  virtual long tellg () {return readSize;};
  virtual bool eod ()=0;

  virtual bool isRandomAccessible () const {return false;};
};
#endif // URL_H
