#include "FileStream.h"
#include "BufferStream.h"

main (int argc,char** argv)
{
  if (argc<2)
    exit (-1);

  const char* const filename=argv[1];
  cout << "DEBUG::now newing ThreadedBuffer" << endl;
  FileStream* fileStream=new FileStream (filename);
  BufferStream* stream=new BufferStream(fileStream);
  assert (stream!=NULL);
  cout << "DEBUG::newed threadedBuffer" << endl;
#define BUFFER_SIZE 1024
  char buffer[BUFFER_SIZE];
  long size;
  while (!stream->eod ())
    {
      cerr << "main::now reading" << endl;
      size=stream->read (buffer,BUFFER_SIZE);
      cerr << "main::size=" << size << endl;
      cout.write (buffer,size) << endl;
    }
#undef BUFFER_SIZE
  stream->printNodeInfo ();
  delete stream;
}
