#include "LZHMember.h"

main (int argc,char** argv)
{
  if (argc<2)
    exit (-1);

  const char* const filename=argv[1];
  LZH* lzh=new LZH (new FileStream (filename));

  DataStream::ChildrenList& list=lzh->getChildrenList ();
  for (DataStream::ChildrenList::iterator i=list.begin ();i!=list.end ();i++)
    {
      cout << (*i)->filename << endl;
      DataStream* stream=lzh->newChild (i);
      assert (stream!=NULL);
#if 0
#define BUFFER_SIZE 1024
      char buffer[BUFFER_SIZE];
      long size;
      while ((size=stream->read (buffer,BUFFER_SIZE))>0)
	{
	  cout << "size=" << size << endl;
	  cout.write (buffer,size) << endl;
	}
#undef BUFFER_SIZE
#endif
      delete stream;
    }
  delete lzh;
}
