#include "FileStream.h"
#include "ThreadedMemoryStream.h"

main (int argc,char** argv)
{
  if (argc<2)
    exit (-1);

  const char* const filename=argv[1];
  cout << "DEBUG::now newing ThreadedBuffer" << endl;
  ThreadedMemoryStream* stream=
    //new ThreadedMemoryStream(new FileStream (filename),false);
    new ThreadedMemoryStream(new FileStream (filename),true);
  assert (stream!=NULL);
  cout << "DEBUG::newed threadedBuffer" << endl;
#define BUFFER_SIZE 1024
  char buffer[BUFFER_SIZE];
  long size;
  while ((size=stream->read (buffer,BUFFER_SIZE))>0)
    {
      cout << "size=" << size << endl;
      cout.write (buffer,size) << endl;
    }
#undef BUFFER_SIZE
  delete stream;
}
