#ifndef RWLock_H
#define RWLock_H

#include "CondVar.h"

class RWLock
{
private:
  Mutex lock;//monitor lock
  int readerNumber;//$BFI$_9~$_(Bthread$B$N?t(B
  int waitingWriters;//write lock$B$r;HMQ$HBT$C$F$$$k(Bthread$B$N?t(B
  bool doesWriting;//$B8=:_(Bwrite lock$B$7$F$$$k$+(B?
  CondVar readOK;
  CondVar writeOK;
public:
  RWLock ();
  ~RWLock ();
  void readLock ();
  void writeLock ();
  void unlock ();
};
#endif //RWLock_H
