#ifndef calcTime_H
#define calcTime_H

#include "Song/SongStatus.h"

struct TimeInfo
{
  uint minute;
  uint second;
  uint milisecond;
};

//$B:F@8;~4V$rF@$k!#(B
TimeInfo calcTime (double logicalTicks)
{
  const int rate = SongStatus::SONG_CTRL_RATE;
  TimeInfo timeInfo;
  timeInfo.minute = static_cast<uint> (logicalTicks/rate/60);
  logicalTicks -= timeInfo.minute*rate*60;
  timeInfo.second = static_cast<uint> (logicalTicks/rate);
  logicalTicks -= timeInfo.second*rate;
  timeInfo.milisecond = static_cast<uint> (logicalTicks*1000/rate);
  return timeInfo;
};
#endif // calcTime_H
