#include "IOtest.h"

int main (int argc,const char** argv)
{
  State state;
  ServerCommand serverCommand;
  Option option;
  IOtest* io=new IOtest (&state, &serverCommand, &option);

  pthread_t ioThread;
  cerr << "now creating io thread." << endl;
  if (io->createPlayLoopThread (&ioThread,NULL) != 0)
    {
      cerr << "create failed." << endl;
    }

  cerr << "now joining" << endl;
  if (pthread_join (ioThread, NULL) != 0)
    {
      cerr << "error:join" << endl;
    }
  
  cout << "all done" << endl;
  delete io;
  exit (0);
}
